/**
 * Tecnología del ocio
 * Bloque 1, unidad didáctica 7
 * Práctica 3
 */

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <cwiid.h>

cwiid_err_t error; //Función para errores

//Función para errores
void error(cwiid_wiimote_t *wiimote, const char *s, va_list ap) {
	if (wiimote != NULL) {printf("Error en el dispositivo %d: ", cwiid_get_id(wiimote));}
	vprintf(s, ap);
	printf("\n");
}

int main(int argc, char *argv[]) {

	cwiid_wiimote_t* wiimote; //Gestor del Wiimote
	bdaddr_t bdaddr; //Dirección Bluetooth del Wiimote
	struct cwiid_state estado; //Estado del Wiimote
	char tmp[256]; //Temporal para mostrar la dirección Bluetooth
	int salir = 0; //Control del bucle principal

	cwiid_set_err(error); //Asigno la función de error

	printf("Poner el Wiimote en modo de descubrimiento (pulsar 1+2) y pulsar enter...\n");
	getchar();
	printf("Buscando...\n");
	bdaddr = *BDADDR_ANY; //Se aceptará la conexión de cualquier Wiimote
	if (!(wiimote = cwiid_connect(&bdaddr, 0))) { //Conexión
		printf("No se pudo detectar wiimote\n");
	}
	else {
		//Conexión establecida
		ba2str(&bdaddr, tmp); //Traducción a cadena de caracteres de la dirección Bluetooth
		printf("Dirección Bluetooth del Wiimote %i: %s\n", cwiid_get_id(wiimote), tmp);
		if (cwiid_set_rpt_mode(wiimote, CWIID_RPT_STATUS)) {
			printf("Error al establecer modo de informe\n");
			salir = 1; //Impido que entre en el bucle
		}
		while (!salir) {
			printf("Pulsa enter para consulta el estado. Escribe x y pulsa enter para salir.\n");
			if (getchar() == 'x') {salir = 1;}
			//Obtención del estado
			if (cwiid_get_state(wiimote, &estado) != 0) {
				printf("Error al obtener el estado del Wiimote\n");
			}
			else {
				if (estado.rpt_mode & CWIID_RPT_STATUS) {
					printf("Batería: %i, accesorio: %i\n", estado.battery, estado.ext_type);
				}
				else {
					printf("El mensaje recibido no es de estado general\n");
				}
				printf("%i\n", estado.buttons);
			}
		}
		if (cwiid_disconnect(wiimote)) { //Desconexión del Wiimote
			printf("Error al desconectar el Wiimote\n");
		}
	}
	return 0;
}
